"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var __assign = undefined && undefined.__assign || Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) {
            if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
    }
    return t;
};
var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var React = require('react');
var typings = require('./json-tree.type');
var classNames = require('classnames');
var index_1 = require('nt-web-tree');
var index_2 = require('nt-transmit-transparently');
require('./json-tree.css');
var stringRender = function stringRender(obj, key) {
    return React.createElement("div", null, React.createElement("span", { className: "key" }, key), ":", React.createElement("span", { className: "string" }, " \"", obj[key], "\""));
};
var numberRender = function numberRender(obj, key) {
    return React.createElement("div", null, React.createElement("span", { className: "key" }, key), ":", React.createElement("span", { className: "number" }, " ", obj[key]));
};
var boolRender = function boolRender(obj, key) {
    return React.createElement("div", null, React.createElement("span", { className: "key" }, key), ":", React.createElement("span", { className: "bool" }, " ", obj[key] ? "true" : "false"));
};
var arrayRender = function arrayRender(obj, key) {
    return React.createElement("div", null, React.createElement("span", { className: "key" }, key), ":", React.createElement("span", { className: "array" }, " Array[", obj[key].length, "]"));
};
var objectRender = function objectRender(obj, key) {
    return React.createElement("div", null, React.createElement("span", { className: "key" }, key), ":", React.createElement("span", { className: "object" }, " Object"));
};
var parseJson = function parseJson(obj) {
    return Object.keys(obj).map(function (key, index) {
        switch (obj[key].constructor.name) {
            case 'String':
                return React.createElement(index_1.TreeNode, { render: stringRender.bind(undefined, obj, key), key: index });
            case 'Number':
                return React.createElement(index_1.TreeNode, { render: numberRender.bind(undefined, obj, key), key: index });
            case 'Boolean':
                return React.createElement(index_1.TreeNode, { render: boolRender.bind(undefined, obj, key), key: index });
            case 'Array':
                var arrayChilds = parseJson(obj[key]);
                return React.createElement(index_1.TreeNode, { render: arrayRender.bind(undefined, obj, key), key: index }, arrayChilds);
            case 'Object':
                var objChilds = parseJson(obj[key]);
                return React.createElement(index_1.TreeNode, { render: objectRender.bind(undefined, obj, key), key: index }, objChilds);
        }
    });
};
var JsonTree = function (_React$Component) {
    _inherits(JsonTree, _React$Component);

    function JsonTree() {
        var _ref;

        _classCallCheck(this, JsonTree);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_ref = JsonTree.__proto__ || Object.getPrototypeOf(JsonTree)).call.apply(_ref, [this].concat(args)));

        _this.state = new typings.State();
        return _this;
    }

    _createClass(JsonTree, [{
        key: "render",
        value: function render() {
            var classes = classNames(_defineProperty({
                'nt-web-json-tree-json_tree': true
            }, this.props.className, !!this.props.className));
            var TreeContent = void 0;
            if (this.props.root) {
                TreeContent = parseJson({
                    root: this.props.json
                });
            } else {
                TreeContent = parseJson(this.props.json);
            }
            return React.createElement(index_1.Tree, __assign({ className: classes }, this.props.others), TreeContent);
        }
    }]);

    return JsonTree;
}(React.Component);
JsonTree.defaultProps = new typings.Props();
JsonTree = __decorate([index_2.TransmitTransparently()], JsonTree);
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = JsonTree;